/* Aliasing */
#include <iostream>

int main() {
  std::string* a = new std::string("My name");
  std::string* b = a; // a is alias for b

  std::cout << *a << std::endl;
  std::cout << *b << std::endl;

  // Assignment to parts of a affects b too
  (*a)[0] = 'X';

  std::cout << *a << std::endl; // Xy name -- no surprise
  std::cout << *b << std::endl; // Xy name -- surprise

  delete a;
  delete b; // runtime error

  return 0;
}
