/* Value semantics of copy constructor */
#include <iostream>

int main() {
  std::string* a = new std::string("My name");
  std::string* b = new std::string(*a); // a is copy of b

  std::cout << *a << std::endl;
  std::cout << *b << std::endl;

  // assignment to parts of a does not affect b
  (*a)[0] = 'X';

  std::cout << *a << std::endl; // Xy name
  std::cout << *b << std::endl; // My name, since a is copy of b

  delete a;
  delete b; // ok now

  return 0;
}
