/* Call by pointer: change in parameter. */
#include <iostream>

void replace_first(std::string* s) {
  (*s)[0] = 'X';
}

// Two ways of writing pointers
int main() {
  std::string name1 = "Fanadu";
  std::string* name2 = new std::string("Fylophone");

  std::cout << name1 << std::endl;
  std::cout << *name2 << std::endl; // Pointer dereference

  // Call-by-pointer: change in parameter. two ways of doing it
  replace_first(&name1);
  replace_first(name2);

  std::cout << name1 << std::endl;
  std::cout << *name2 << std::endl;

  delete name2;

  return 0;
}
