/* Call-by-value takes a lot of time */
#include <iostream>
#include <ctime>

char get_first1(std::string s) {
  s[0] = 'X';
  return s[0];
}

char get_first2(std::string* s) {
  (*s)[0] = 'X';
  return (*s)[0];
}

int main() {
  std::string name1 = "Fanadu";
  int limit = 10000000;

  time_t now = time(0);
  for (int i = 0; i < limit; i++) {
    (void) get_first1(name1);
  }
  std::cout << difftime(time(0), now) << std::endl;

  now = time(0);
  for (int i = 0; i < limit; i++) {
    (void) get_first2(&name1);
  }
  std::cout << difftime(time(0), now) << std::endl;

  return 0;
}
